Index: cpukit/libblock/src/bdbuf.c
===================================================================
--- cpukit/libblock/src/bdbuf.c	(revision 72d2ec4da4ea788335adf921faebf0ac96d67c93)
+++ cpukit/libblock/src/bdbuf.c	(revision 3899a5379f4bfa067e73b4612a547a308a6634ec)
@@ -1814,42 +2381,43 @@
  */
 rtems_status_code
-rtems_bdbuf_find_pool(int block_size, rtems_bdpool_id *pool)
-{
-    rtems_bdpool_id i;
-    bdbuf_pool *p;
-    int cursize = INT_MAX;
-    rtems_bdpool_id curid = -1;
-    rtems_boolean found = FALSE;
-    int j;
-
-    for (j = block_size; (j != 0) && ((j & 1) == 0); j >>= 1);
-    if (j != 1)
-        return RTEMS_INVALID_SIZE;
-
-    for (i = 0, p = rtems_bdbuf_ctx.pool; i < rtems_bdbuf_ctx.npools; i++, p++)
-    {
-        if ((p->blksize >= block_size) &&
-            (p->blksize < cursize))
-        {
-            curid = i;
-            cursize = p->blksize;
-            found = TRUE;
-        }
-    }
-
-    if (found)
-    {
-        if (pool != NULL)
-            *pool = curid;
-        return RTEMS_SUCCESSFUL;
-    }
-    else
-    {
-        return RTEMS_NOT_DEFINED;
-    }
-}
-
-/* rtems_bdbuf_get_pool_info --
- *     Obtain characteristics of buffer pool with specified number.
+rtems_bdbuf_find_pool (int block_size, rtems_bdpool_id *pool)
+{
+  rtems_bdbuf_pool* p;
+  rtems_bdpool_id   i;
+  rtems_bdpool_id   curid = -1;
+  rtems_boolean     found = FALSE;
+  int               cursize = INT_MAX;
+  int               j;
+
+  for (j = block_size; (j != 0) && ((j & 1) == 0); j >>= 1);
+  if (j != 1)
+    return RTEMS_INVALID_SIZE;
+
+  for (i = 0; i < rtems_bdbuf_ctx.npools; i++)
+  {
+    p = rtems_bdbuf_get_pool (i);
+    if ((p->blksize >= block_size) &&
+        (p->blksize < cursize))
+    {
+      curid = i;
+      cursize = p->blksize;
+      found = TRUE;
+    }
+  }
+
+  if (found)
+  {
+    if (pool != NULL)
+      *pool = curid;
+    return RTEMS_SUCCESSFUL;
+  }
+  else
+  {
+    return RTEMS_NOT_DEFINED;
+  }
+}
+
+/**
+ * Obtain characteristics of buffer pool with specified number.
  *
  * PARAMETERS:
@@ -1867,20 +2435,19 @@
  */
 rtems_status_code
-rtems_bdbuf_get_pool_info(rtems_bdpool_id pool, int *block_size,
-                          int *blocks)
-{
-    if (pool >= rtems_bdbuf_ctx.npools)
-        return RTEMS_INVALID_NUMBER;
-
-    if (block_size != NULL)
-    {
-        *block_size = rtems_bdbuf_ctx.pool[pool].blksize;
-    }
-
-    if (blocks != NULL)
-    {
-        *blocks = rtems_bdbuf_ctx.pool[pool].nblks;
-    }
-
-    return RTEMS_SUCCESSFUL;
-}
+rtems_bdbuf_get_pool_info(rtems_bdpool_id pool, int* block_size, int* blocks)
+{
+  if (pool >= rtems_bdbuf_ctx.npools)
+    return RTEMS_INVALID_NUMBER;
+
+  if (block_size != NULL)
+  {
+    *block_size = rtems_bdbuf_ctx.pool[pool].blksize;
+  }
+
+  if (blocks != NULL)
+  {
+    *blocks = rtems_bdbuf_ctx.pool[pool].nblks;
+  }
+
+  return RTEMS_SUCCESSFUL;
+}
Index: cpukit/libblock/src/blkdev.c
===================================================================
--- cpukit/libblock/src/blkdev.c	(revision 72d2ec4da4ea788335adf921faebf0ac96d67c93)
+++ cpukit/libblock/src/blkdev.c	(revision 3899a5379f4bfa067e73b4612a547a308a6634ec)
@@ -39,8 +39,8 @@
     unsigned int blkofs;
     dev_t dev;
-    disk_device *dd;
-
-    dev = rtems_filesystem_make_dev_t(major, minor);
-    dd = rtems_disk_lookup(dev);
+    rtems_disk_device *dd;
+
+    dev = rtems_filesystem_make_dev_t(major, minor);
+    dd = rtems_disk_obtain(dev);
     if (dd == NULL)
         return RTEMS_INVALID_NUMBER;
@@ -58,5 +58,5 @@
     while (count > 0)
     {
-        bdbuf_buffer *diskbuf;
+        rtems_bdbuf_buffer *diskbuf;
         int copy;
         rtems_status_code rc;
@@ -100,8 +100,8 @@
     dev_t dev;
     rtems_status_code rc;
-    disk_device *dd;
-
-    dev = rtems_filesystem_make_dev_t(major, minor);
-    dd = rtems_disk_lookup(dev);
+    rtems_disk_device *dd;
+
+    dev = rtems_filesystem_make_dev_t(major, minor);
+    dd = rtems_disk_obtain(dev);
     if (dd == NULL)
         return RTEMS_INVALID_NUMBER;
@@ -119,5 +119,5 @@
     while (count > 0)
     {
-        bdbuf_buffer *diskbuf;
+        rtems_bdbuf_buffer *diskbuf;
         int copy;
 
@@ -157,8 +157,8 @@
 {
     dev_t dev;
-    disk_device *dd;
-
-    dev = rtems_filesystem_make_dev_t(major, minor);
-    dd = rtems_disk_lookup(dev);
+    rtems_disk_device *dd;
+
+    dev = rtems_filesystem_make_dev_t(major, minor);
+    dd = rtems_disk_obtain(dev);
     if (dd == NULL)
         return RTEMS_INVALID_NUMBER;
@@ -182,8 +182,8 @@
 {
     dev_t dev;
-    disk_device *dd;
-
-    dev = rtems_filesystem_make_dev_t(major, minor);
-    dd = rtems_disk_lookup(dev);
+    rtems_disk_device *dd;
+
+    dev = rtems_filesystem_make_dev_t(major, minor);
+    dd = rtems_disk_obtain(dev);
     if (dd == NULL)
         return RTEMS_INVALID_NUMBER;
@@ -207,9 +207,9 @@
     rtems_libio_ioctl_args_t *args = arg;
     dev_t dev;
-    disk_device *dd;
+    rtems_disk_device *dd;
     int rc;
 
     dev = rtems_filesystem_make_dev_t(major, minor);
-    dd = rtems_disk_lookup(dev);
+    dd = rtems_disk_obtain(dev);
     if (dd == NULL)
         return RTEMS_INVALID_NUMBER;
@@ -217,20 +217,20 @@
     switch (args->command)
     {
-        case BLKIO_GETBLKSIZE:
+        case RTEMS_BLKIO_GETBLKSIZE:
             args->ioctl_return = dd->block_size;
             break;
 
-        case BLKIO_GETSIZE:
+        case RTEMS_BLKIO_GETSIZE:
             args->ioctl_return = dd->size;
             break;
 
-        case BLKIO_SYNCDEV:
+        case RTEMS_BLKIO_SYNCDEV:
             rc = rtems_bdbuf_syncdev(dd->dev);
             args->ioctl_return = (rc == RTEMS_SUCCESSFUL ? 0 : -1);
             break;
 
-        case BLKIO_REQUEST:
+        case RTEMS_BLKIO_REQUEST:
         {
-            blkdev_request *req = args->buffer;
+            rtems_blkdev_request *req = args->buffer;
             req->start += dd->start;
             args->ioctl_return = dd->ioctl(dd->phys_dev->dev, args->command,
Index: cpukit/libblock/src/diskdevs.c
===================================================================
--- cpukit/libblock/src/diskdevs.c	(revision 72d2ec4da4ea788335adf921faebf0ac96d67c93)
+++ cpukit/libblock/src/diskdevs.c	(revision 3899a5379f4bfa067e73b4612a547a308a6634ec)
@@ -24,11 +24,11 @@
 
 /* Table of disk devices having the same major number */
-struct disk_device_table {
-    disk_device **minor; /* minor-indexed disk device table */
+typedef struct rtems_disk_device_table {
+    rtems_disk_device **minor; /* minor-indexed disk device table */
     int size;            /* Number of entries in the table */
-};
+} rtems_disk_device_table;
 
 /* Pointer to [major].minor[minor] indexed array of disk devices */
-static struct disk_device_table *disktab;
+static rtems_disk_device_table *disktab;
 
 /* Number of allocated entries in disktab table */
@@ -65,10 +65,10 @@
  *     available for its creation.
  */
-static disk_device *
+static rtems_disk_device *
 create_disk_entry(dev_t dev)
 {
     rtems_device_major_number major;
     rtems_device_minor_number minor;
-    struct disk_device **d;
+    rtems_disk_device **d;
 
     rtems_filesystem_split_dev_t (dev, major, minor);
@@ -76,5 +76,5 @@
     if (major >= disktab_size)
     {
-        struct disk_device_table *p;
+        rtems_disk_device_table *p;
         int newsize;
         int i;
@@ -82,5 +82,5 @@
         if (major >= newsize)
             newsize = major + 1;
-        p = realloc(disktab, sizeof(struct disk_device_table) * newsize);
+        p = realloc(disktab, sizeof(rtems_disk_device_table) * newsize);
         if (p == NULL)
             return NULL;
@@ -98,5 +98,5 @@
     {
         int newsize;
-        disk_device **p;
+        rtems_disk_device **p;
         int i;
         int s = disktab[major].size;
@@ -109,5 +109,6 @@
             newsize = minor + 1;
 
-        p = realloc(disktab[major].minor, sizeof(disk_device *) * newsize);
+        p = realloc(disktab[major].minor,
+                    sizeof(rtems_disk_device *) * newsize);
         if (p == NULL)
             return NULL;
@@ -122,5 +123,5 @@
     if (*d == NULL)
     {
-        *d = calloc(1, sizeof(disk_device));
+        *d = calloc(1, sizeof(rtems_disk_device));
     }
     return *d;
@@ -137,10 +138,10 @@
  *     device number, or NULL if disk device with such number not exists.
  */
-static inline disk_device *
+static rtems_disk_device *
 get_disk_entry(dev_t dev)
 {
     rtems_device_major_number major;
     rtems_device_minor_number minor;
-    struct disk_device_table *dtab;
+    rtems_disk_device_table *dtab;
 
     rtems_filesystem_split_dev_t (dev, major, minor);
@@ -172,7 +173,7 @@
  */
 static rtems_status_code
-create_disk(dev_t dev, const char *name, disk_device **diskdev)
-{
-    disk_device *dd;
+create_disk(dev_t dev, const char *name, rtems_disk_device **diskdev)
+{
+    rtems_disk_device *dd;
     char *n;
 
@@ -235,10 +236,10 @@
 rtems_status_code
 rtems_disk_create_phys(dev_t dev, int block_size, int disk_size,
-                       block_device_ioctl handler,
+                       rtems_block_device_ioctl handler,
                        const char *name)
 {
     int bs_log2;
     int i;
-    disk_device *dd;
+    rtems_disk_device *dd;
     rtems_status_code rc;
     rtems_bdpool_id pool;
@@ -285,4 +286,9 @@
     rc = rtems_io_register_name(name, major, minor);
 
+    if (handler (dd->phys_dev->dev,
+                 RTEMS_BLKDEV_CAPABILITIES,
+                 &dd->capabilities) < 0)
+      dd->capabilities = 0;
+    
     diskdevs_protected = FALSE;
     rtems_semaphore_release(diskdevs_mutex);
@@ -318,6 +324,6 @@
 rtems_disk_create_log(dev_t dev, dev_t phys, int start, int size, char *name)
 {
-    disk_device *dd;
-    disk_device *pdd;
+    rtems_disk_device *dd;
+    rtems_disk_device *pdd;
     rtems_status_code rc;
     rtems_device_major_number major;
@@ -394,10 +400,10 @@
     for (maj = 0; maj < disktab_size; maj++)
     {
-        struct disk_device_table *dtab = disktab + maj;
+        rtems_disk_device_table *dtab = disktab + maj;
         if (dtab != NULL)
         {
             for (min = 0; min < dtab->size; min++)
             {
-                disk_device *dd = dtab->minor[min];
+                rtems_disk_device *dd = dtab->minor[min];
                 if ((dd != NULL) && (dd->phys_dev->dev == dev))
                     used += dd->uses;
@@ -416,10 +422,10 @@
     for (maj = 0; maj < disktab_size; maj++)
     {
-        struct disk_device_table *dtab = disktab +maj;
+        rtems_disk_device_table *dtab = disktab +maj;
         if (dtab != NULL)
         {
             for (min = 0; min < dtab->size; min++)
             {
-                disk_device *dd = dtab->minor[min];
+                rtems_disk_device *dd = dtab->minor[min];
                 if ((dd != NULL) && (dd->phys_dev->dev == dev))
                 {
@@ -438,5 +444,5 @@
 }
 
-/* rtems_disk_lookup --
+/* rtems_disk_obtain --
  *     Find block device descriptor by its device identifier.
  *
@@ -448,9 +454,9 @@
  *     exists.
  */
-disk_device *
-rtems_disk_lookup(dev_t dev)
+rtems_disk_device *
+rtems_disk_obtain(dev_t dev)
 {
     rtems_interrupt_level level;
-    disk_device *dd;
+    rtems_disk_device *dd;
     rtems_status_code rc;
 
@@ -481,5 +487,5 @@
 
 /* rtems_disk_release --
- *     Release disk_device structure (decrement usage counter to 1).
+ *     Release rtems_disk_device structure (decrement usage counter to 1).
  *
  * PARAMETERS:
@@ -490,5 +496,5 @@
  */
 rtems_status_code
-rtems_disk_release(disk_device *dd)
+rtems_disk_release(rtems_disk_device *dd)
 {
     rtems_interrupt_level level;
@@ -511,10 +517,10 @@
  *     devices enumerated.
  */
-disk_device *
+rtems_disk_device *
 rtems_disk_next(dev_t dev)
 {
     rtems_device_major_number major;
     rtems_device_minor_number minor;
-    struct disk_device_table *dtab;
+    rtems_disk_device_table *dtab;
 
     dev++;
@@ -563,5 +569,5 @@
 
     disktab_size = DISKTAB_INITIAL_SIZE;
-    disktab = calloc(disktab_size, sizeof(struct disk_device_table));
+    disktab = calloc(disktab_size, sizeof(rtems_disk_device_table));
     if (disktab == NULL)
         return RTEMS_NO_MEMORY;
@@ -579,6 +585,5 @@
     }
 
-    rc = rtems_bdbuf_init(rtems_bdbuf_configuration,
-                          rtems_bdbuf_configuration_size);
+    rc = rtems_bdbuf_init();
 
     if (rc != RTEMS_SUCCESSFUL)
@@ -613,10 +618,10 @@
     for (maj = 0; maj < disktab_size; maj++)
     {
-        struct disk_device_table *dtab = disktab + maj;
+        rtems_disk_device_table *dtab = disktab + maj;
         if (dtab != NULL)
         {
             for (min = 0; min < dtab->size; min++)
             {
-                disk_device *dd = dtab->minor[min];
+                rtems_disk_device *dd = dtab->minor[min];
                 unlink(dd->name);
                 free(dd->name);
Index: cpukit/libblock/src/flashdisk.c
===================================================================
--- cpukit/libblock/src/flashdisk.c	(revision 72d2ec4da4ea788335adf921faebf0ac96d67c93)
+++ cpukit/libblock/src/flashdisk.c	(revision 3899a5379f4bfa067e73b4612a547a308a6634ec)
@@ -2058,12 +2058,11 @@
  */
 static int
-rtems_fdisk_read (rtems_flashdisk* fd, blkdev_request* req)
-{
-  blkdev_sg_buffer* sg = req->bufs;
-  uint32_t          block = req->start;
-  uint32_t          b;
-  int               ret = 0;
-
-  for (b = 0; b < req->bufnum; b++, block++, sg++)
+rtems_fdisk_read (rtems_flashdisk* fd, rtems_blkdev_request* req)
+{
+  rtems_blkdev_sg_buffer* sg = req->bufs;
+  uint32_t                b;
+  int                     ret = 0;
+
+  for (b = 0; b < req->bufnum; b++, sg++)
   {
     uint32_t length = sg->length;
@@ -2078,5 +2077,5 @@
     }
 
-    ret = rtems_fdisk_read_block (fd, block, sg->buffer);
+    ret = rtems_fdisk_read_block (fd, sg->block, sg->buffer);
 
     if (ret)
@@ -2099,12 +2098,11 @@
  */
 static int
-rtems_fdisk_write (rtems_flashdisk* fd, blkdev_request* req)
-{
-  blkdev_sg_buffer* sg = req->bufs;
-  uint32_t          block = req->start;
-  uint32_t          b;
-  int               ret = 0;
-
-  for (b = 0; b < req->bufnum; b++, block++, sg++)
+rtems_fdisk_write (rtems_flashdisk* fd, rtems_blkdev_request* req)
+{
+  rtems_blkdev_sg_buffer* sg = req->bufs;
+  uint32_t                b;
+  int                     ret = 0;
+
+  for (b = 0; b < req->bufnum; b++, sg++)
   {
     if (sg->length != fd->block_size)
@@ -2114,5 +2112,5 @@
     }
 
-    ret = rtems_fdisk_write_block (fd, block, sg->buffer);
+    ret = rtems_fdisk_write_block (fd, sg->block, sg->buffer);
 
     if (ret)
@@ -2357,5 +2355,5 @@
 {
   rtems_device_minor_number minor = rtems_filesystem_dev_minor_t (dev);
-  blkdev_request*           r = argp;
+  rtems_blkdev_request*     r = argp;
   rtems_status_code         sc;
 
@@ -2369,5 +2367,5 @@
     switch (req)
     {
-      case BLKIO_REQUEST:
+      case RTEMS_BLKIO_REQUEST:
         if ((minor >= rtems_flashdisk_count) ||
             (rtems_flashdisks[minor].device_count == 0))
@@ -2379,9 +2377,9 @@
           switch (r->req)
           {
-            case BLKDEV_REQ_READ:
+            case RTEMS_BLKDEV_REQ_READ:
               errno = rtems_fdisk_read (&rtems_flashdisks[minor], r);
               break;
 
-            case BLKDEV_REQ_WRITE:
+            case RTEMS_BLKDEV_REQ_WRITE:
               errno = rtems_fdisk_write (&rtems_flashdisks[minor], r);
               break;
Index: cpukit/libblock/src/ide_part_table.c
===================================================================
--- cpukit/libblock/src/ide_part_table.c	(revision 72d2ec4da4ea788335adf921faebf0ac96d67c93)
+++ cpukit/libblock/src/ide_part_table.c	(revision 3899a5379f4bfa067e73b4612a547a308a6634ec)
@@ -47,9 +47,9 @@
  */
 static rtems_status_code
-get_sector(dev_t dev, uint32_t sector_num, sector_data_t **sector)
-{
-    sector_data_t      *s;
-    bdbuf_buffer       *buf;
-    rtems_status_code   rc;
+get_sector(dev_t dev, uint32_t sector_num, rtems_sector_data_t **sector)
+{
+    rtems_sector_data_t *s;
+    rtems_bdbuf_buffer  *buf;
+    rtems_status_code    rc;
 
     if (sector == NULL)
@@ -58,5 +58,5 @@
     }
 
-    s = (sector_data_t *) malloc(sizeof(sector_data_t) + RTEMS_IDE_SECTOR_SIZE);
+    s = (rtems_sector_data_t *) malloc(sizeof(rtems_sector_data_t) + RTEMS_IDE_SECTOR_SIZE);
     if (s == NULL)
     {
@@ -93,5 +93,5 @@
  */
 static rtems_boolean
-msdos_signature_check (sector_data_t *sector)
+msdos_signature_check (rtems_sector_data_t *sector)
 {
     uint8_t *p = sector->data + RTEMS_IDE_PARTITION_MSDOS_SIGNATURE_OFFSET;
@@ -157,8 +157,8 @@
  */
 static rtems_status_code
-data_to_part_desc(uint8_t *data, part_desc_t **new_part_desc)
-{
-    part_desc_t *part_desc;
-    uint32_t     temp;
+data_to_part_desc(uint8_t *data, rtems_part_desc_t **new_part_desc)
+{
+    rtems_part_desc_t *part_desc;
+    uint32_t           temp;
 
     if (new_part_desc == NULL)
@@ -169,5 +169,5 @@
     *new_part_desc = NULL;
 
-    if ((part_desc = calloc(1, sizeof(part_desc_t))) == NULL)
+    if ((part_desc = calloc(1, sizeof(rtems_part_desc_t))) == NULL)
     {
         return RTEMS_NO_MEMORY;
@@ -220,13 +220,13 @@
  */
 static rtems_status_code
-read_extended_partition(uint32_t start, part_desc_t *ext_part)
-{
-    int                 i;
-    dev_t               dev;
-    sector_data_t      *sector;
-    uint32_t            here;
-    uint8_t            *data;
-    part_desc_t        *new_part_desc;
-    rtems_status_code   rc;
+read_extended_partition(uint32_t start, rtems_part_desc_t *ext_part)
+{
+    int                  i;
+    dev_t                dev;
+    rtems_sector_data_t *sector;
+    uint32_t             here;
+    uint8_t             *data;
+    rtems_part_desc_t   *new_part_desc;
+    rtems_status_code    rc;
 
     if ((ext_part == NULL) || (ext_part->disk_desc == NULL))
@@ -287,5 +287,5 @@
         else
         {
-            disk_desc_t *disk_desc = new_part_desc->disk_desc;
+            rtems_disk_desc_t *disk_desc = new_part_desc->disk_desc;
             disk_desc->partitions[disk_desc->last_log_id] = new_part_desc;
             new_part_desc->log_id = ++disk_desc->last_log_id;
@@ -315,12 +315,12 @@
  */
 static rtems_status_code
-read_mbr(disk_desc_t *disk_desc)
-{
-    int                 part_num;
-    sector_data_t      *sector;
-    part_desc_t        *part_desc;
-    uint8_t            *data;
-    rtems_status_code   rc;
-    dev_t               dev = disk_desc->dev;
+read_mbr(rtems_disk_desc_t *disk_desc)
+{
+    int                  part_num;
+    rtems_sector_data_t *sector;
+    rtems_part_desc_t   *part_desc;
+    uint8_t             *data;
+    rtems_status_code    rc;
+    dev_t                dev = disk_desc->dev;
 
     /* get MBR sector */
@@ -399,5 +399,5 @@
  */
 static void
-partition_free(part_desc_t *part_desc)
+partition_free(rtems_part_desc_t *part_desc)
 {
     int part_num;
@@ -430,5 +430,5 @@
  */
 void
-rtems_ide_part_table_free(disk_desc_t *disk_desc)
+rtems_ide_part_table_free(rtems_disk_desc_t *disk_desc)
 {
     int part_num;
@@ -456,5 +456,5 @@
  */
 rtems_status_code
-rtems_ide_part_table_get(const char *dev_name, disk_desc_t *disk_desc)
+rtems_ide_part_table_get(const char *dev_name, rtems_disk_desc_t *disk_desc)
 {
     struct stat         dev_stat;
@@ -495,14 +495,14 @@
     int                         part_num;
     dev_t                       dev;
-    disk_desc_t                *disk_desc;
+    rtems_disk_desc_t          *disk_desc;
     rtems_device_major_number   major;
     rtems_device_minor_number   minor;
     rtems_status_code           rc;
-    part_desc_t                *part_desc;
+    rtems_part_desc_t          *part_desc;
 
     /* logical device name /dev/hdxyy */
     char                        name[RTEMS_IDE_PARTITION_DEV_NAME_LENGTH_MAX];
 
-    disk_desc = (disk_desc_t *) calloc(1, sizeof(disk_desc_t));
+    disk_desc = (rtems_disk_desc_t *) calloc(1, sizeof(rtems_disk_desc_t));
     if (disk_desc == NULL)
     {
Index: cpukit/libblock/src/nvdisk.c
===================================================================
--- cpukit/libblock/src/nvdisk.c	(revision 72d2ec4da4ea788335adf921faebf0ac96d67c93)
+++ cpukit/libblock/src/nvdisk.c	(revision 3899a5379f4bfa067e73b4612a547a308a6634ec)
@@ -52,5 +52,5 @@
  */
 #if !defined (RTEMS_NVDISK_TRACE)
-#define RTEMS_NVDISK_TRACE 1
+#define RTEMS_NVDISK_TRACE 0
 #endif
 
@@ -166,5 +166,5 @@
  * Print a message to the nvdisk output and flush it.
  *
- * @param fd The flashdisk control structure.
+ * @param nvd The nvdisk control structure.
  * @param format The format string. See printf for details.
  * @param ... The arguments for the format text.
@@ -190,5 +190,5 @@
  * Print a info message to the nvdisk output and flush it.
  *
- * @param fd The flashdisk control structure.
+ * @param nvd The nvdisk control structure.
  * @param format The format string. See printf for details.
  * @param ... The arguments for the format text.
@@ -214,5 +214,5 @@
  * Print a warning to the nvdisk output and flush it.
  *
- * @param fd The flashdisk control structure.
+ * @param nvd The nvdisk control structure.
  * @param format The format string. See printf for details.
  * @param ... The arguments for the format text.
@@ -257,22 +257,4 @@
 
 /**
- * Print an abort message, flush it then abort the program.
- *
- * @param format The format string. See printf for details.
- * @param ... The arguments for the format text.
- */
-static void
-rtems_nvdisk_abort (const char *format, ...)
-{
-  va_list args;
-  va_start (args, format);
-  fprintf (stderr, "nvdisk:abort:");
-  vfprintf (stderr, format, args);
-  fprintf (stderr, "\n");
-  fflush (stderr);
-  exit (1);
-}
-
-/**
  * Get the descriptor for a device.
  */
@@ -325,4 +307,5 @@
 }
 
+#if NOT_USED
 /**
  * Verify the data with the data in a segment.
@@ -345,4 +328,5 @@
   return ops->verify (device, dd->flags, dd->base, offset, buffer, size); 
 }
+#endif
 
 /**
@@ -372,18 +356,4 @@
                                     page * nvd->block_size,
                                     buffer, nvd->block_size);
-}
-
-/**
- * Verify a page of data with the data in the device.
- */
-static int
-rtems_nvdisk_verify_page (const rtems_nvdisk* nvd,
-                          uint32_t            device,
-                          uint32_t            page,
-                          const void*         buffer)
-{
-  return rtems_nvdisk_device_verify (nvd, device,
-                                     page * nvd->block_size,
-                                     buffer, nvd->block_size);
 }
 
@@ -533,5 +503,7 @@
   if (crc == 0xffff)
   {
+#if RTEMS_NVDISK_TRACE
     rtems_nvdisk_warning (nvd, "read-block: crc not set: %d", block);
+#endif
     memset (buffer, 0, nvd->block_size);
     return 0;
@@ -606,11 +578,10 @@
  */
 static int
-rtems_nvdisk_read (rtems_nvdisk* nvd, blkdev_request* req)
-{
-  blkdev_sg_buffer* sg = req->bufs;
-  uint32_t          block = req->start;
-  uint32_t          b;
-  int32_t           remains;
-  int               ret = 0;
+rtems_nvdisk_read (rtems_nvdisk* nvd, rtems_blkdev_request* req)
+{
+  rtems_blkdev_sg_buffer* sg = req->bufs;
+  uint32_t                b;
+  int32_t                 remains;
+  int                     ret = 0;
 
 #if RTEMS_NVDISK_TRACE
@@ -620,5 +591,5 @@
   remains = req->count * nvd->block_size;
   
-  for (b = 0; b < req->bufnum; b++, block++, sg++)
+  for (b = 0; b < req->bufnum; b++, sg++)
   {
     uint32_t length = sg->length;
@@ -659,10 +630,9 @@
  */
 static int
-rtems_nvdisk_write (rtems_nvdisk* nvd, blkdev_request* req)
-{
-  blkdev_sg_buffer* sg = req->bufs;
-  uint32_t          block = req->start;
-  uint32_t          b;
-  int               ret = 0;
+rtems_nvdisk_write (rtems_nvdisk* nvd, rtems_blkdev_request* req)
+{
+  rtems_blkdev_sg_buffer* sg = req->bufs;
+  uint32_t                b;
+  int                     ret = 0;
 
 #if RTEMS_NVDISK_TRACE
@@ -670,5 +640,5 @@
 #endif
 
-  for (b = 0; b < req->bufnum; b++, block++, sg++)
+  for (b = 0; b < req->bufnum; b++, sg++)
   {
     if (sg->length != nvd->block_size)
@@ -721,5 +691,5 @@
 
 /**
- * MV disk IOCTL handler.
+ * NV disk IOCTL handler.
  *
  * @param dev Device number (major, minor number).
@@ -732,7 +702,19 @@
 {
   rtems_device_minor_number minor = rtems_filesystem_dev_minor_t (dev);
-  blkdev_request*           r = argp;
+  rtems_blkdev_request*     r = argp;
   rtems_status_code         sc;
 
+  if (minor >= rtems_nvdisk_count)
+  {
+    errno = ENODEV;
+    return -1;
+  }
+        
+  if (rtems_nvdisks[minor].device_count == 0)
+  {
+    errno = ENODEV;
+    return -1;
+  }
+        
   errno = 0;
 
@@ -744,26 +726,18 @@
     switch (req)
     {
-      case BLKIO_REQUEST:
-        if ((minor >= rtems_nvdisk_count) ||
-            (rtems_nvdisks[minor].device_count == 0))
+      case RTEMS_BLKIO_REQUEST:
+        switch (r->req)
         {
-          errno = ENODEV;
-        }
-        else
-        {
-          switch (r->req)
-          {
-            case BLKDEV_REQ_READ:
-              errno = rtems_nvdisk_read (&rtems_nvdisks[minor], r);
-              break;
-
-            case BLKDEV_REQ_WRITE:
-              errno = rtems_nvdisk_write (&rtems_nvdisks[minor], r);
-              break;
-        
-            default:
-              errno = EBADRQC;
-              break;
-          }
+          case RTEMS_BLKDEV_REQ_READ:
+            errno = rtems_nvdisk_read (&rtems_nvdisks[minor], r);
+            break;
+            
+          case RTEMS_BLKDEV_REQ_WRITE:
+            errno = rtems_nvdisk_write (&rtems_nvdisks[minor], r);
+            break;
+            
+          default:
+            errno = EBADRQC;
+            break;
         }
         break;
@@ -772,9 +746,9 @@
         errno = rtems_nvdisk_erase_disk (&rtems_nvdisks[minor]);
         break;
-
+        
       case RTEMS_NVDISK_IOCTL_INFO_LEVEL:
         rtems_nvdisks[minor].info_level = (uint32_t) argp;
         break;
-
+        
       default:
         errno = EBADRQC;
Index: cpukit/libblock/src/ramdisk.c
===================================================================
--- cpukit/libblock/src/ramdisk.c	(revision 72d2ec4da4ea788335adf921faebf0ac96d67c93)
+++ cpukit/libblock/src/ramdisk.c	(revision 3899a5379f4bfa067e73b4612a547a308a6634ec)
@@ -22,4 +22,12 @@
 #include "rtems/diskdevs.h"
 #include "rtems/ramdisk.h"
+
+/**
+ * Control tracing. It can be compiled out of the code for small
+ * footprint targets. Leave in by default.
+ */
+#if !defined (RTEMS_RAMDISK_TRACE)
+#define RTEMS_RAMDISK_TRACE 0
+#endif
 
 #define RAMDISK_DEVICE_BASE_NAME "/dev/ramdisk"
@@ -33,8 +41,37 @@
     rtems_boolean malloced;   /* != 0, if memory allocated by malloc for this
                                  RAM disk */
+#if RTEMS_RAMDISK_TRACE
+    int           info_level; /* Trace level */
+#endif
 };
 
 static struct ramdisk *ramdisk;
 static int nramdisks;
+
+#if RTEMS_RAMDISK_TRACE
+/**
+ * Print a message to the ramdisk output and flush it.
+ *
+ * @param rd The ramdisk control structure.
+ * @param format The format string. See printf for details.
+ * @param ... The arguments for the format text.
+ * @return int The number of bytes written to the output.
+ */
+static int
+rtems_ramdisk_printf (struct ramdisk *rd, const char *format, ...)
+{
+  int ret = 0;
+  if (rd->info_level >= 1)
+  {
+    va_list args;
+    va_start (args, format);
+    fprintf (stdout, "ramdisk:");
+    ret =  vfprintf (stdout, format, args);
+    fprintf (stdout, "\n");
+    fflush (stdout);
+  }
+  return ret;
+}
+#endif
 
 /* ramdisk_read --
@@ -50,12 +87,17 @@
  */
 static int
-ramdisk_read(struct ramdisk *rd, blkdev_request *req)
+ramdisk_read(struct ramdisk *rd, rtems_blkdev_request *req)
 {
     char *from;
     uint32_t   i;
-    blkdev_sg_buffer *sg;
+    rtems_blkdev_sg_buffer *sg;
     uint32_t   remains;
 
-    from = (char *)rd->area + (req->start * rd->block_size);
+#if RTEMS_RAMDISK_TRACE
+    rtems_ramdisk_printf (rd, "ramdisk read: start=%d, blocks=%d remains=%d",
+                          req->bufs[0].block, req->bufnum,
+                          rd->block_size * req->count);
+#endif
+
     remains = rd->block_size * req->count;
     sg = req->bufs;
@@ -63,4 +105,5 @@
     {
         int count = sg->length;
+        from = ((char *)rd->area + (sg->block * rd->block_size));
         if (count > remains)
             count = remains;
@@ -85,12 +128,16 @@
  */
 static int
-ramdisk_write(struct ramdisk *rd, blkdev_request *req)
+ramdisk_write(struct ramdisk *rd, rtems_blkdev_request *req)
 {
     char *to;
     uint32_t   i;
-    blkdev_sg_buffer *sg;
+    rtems_blkdev_sg_buffer *sg;
     uint32_t   remains;
 
-    to = (char *)rd->area + (req->start * rd->block_size);
+#if RTEMS_RAMDISK_TRACE
+    rtems_ramdisk_printf (rd, "ramdisk write: start=%d, blocks=%d remains=%d",
+                          req->bufs[0].block, req->bufnum,
+                          rd->block_size * req->count);
+#endif
     remains = rd->block_size * req->count;
     sg = req->bufs;
@@ -98,4 +145,5 @@
     {
         int count = sg->length;
+        to = ((char *)rd->area + (sg->block * rd->block_size));
         if (count > remains)
             count = remains;
@@ -124,8 +172,8 @@
     switch (req)
     {
-        case BLKIO_REQUEST:
+        case RTEMS_BLKIO_REQUEST:
         {
             rtems_device_minor_number minor;
-            blkdev_request *r = argp;
+            rtems_blkdev_request *r = argp;
             struct ramdisk *rd;
 
@@ -141,8 +189,8 @@
             switch (r->req)
             {
-                case BLKDEV_REQ_READ:
+                case RTEMS_BLKDEV_REQ_READ:
                     return ramdisk_read(rd, r);
 
-                case BLKDEV_REQ_WRITE:
+                case RTEMS_BLKDEV_REQ_WRITE:
                     return ramdisk_write(rd, r);
 
@@ -189,5 +237,7 @@
     r = ramdisk = calloc(rtems_ramdisk_configuration_size,
                          sizeof(struct ramdisk));
-
+#if RTEMS_RAMDISK_TRACE
+    r->info_level = 1;
+#endif   
     for (i = 0; i < rtems_ramdisk_configuration_size; i++, c++, r++)
     {
